summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2012-07-13 02:27:26 +0100
committerPádraig Brady <P@draigBrady.com>2012-07-16 02:48:31 +0100
commit3ed70fd559c3fbed8383b50373e6d23d1857dc52 (patch)
tree89b15d9f2f62a6263993183648624b5b57a922f6 /tests
parentac00d23e1a90dc5a8cd0f6de0e61eb401d5089d5 (diff)
downloadcoreutils-3ed70fd559c3fbed8383b50373e6d23d1857dc52.tar.xz
df: don't output control characters in a mount point name
It's awkward to read and problematic for scripts when control characters like '\n' are output. Note other fields are already handled with mbsalign, which converts non printable chars to the replacement char. A caveat to note with that, is the replacement char takes a place in the field and so possibly truncates the field if it was the widest field in the records. Note a more general replacement function, that handles all printable, or non white space characters, would require more sophisticated support for various encodings, and the complexity vs benefit was not deemed beneficial enough at present. Perhaps in future a more general replacement function could be shared between the various utilities. Note <space> is unaffected in any field, which could impact scripts processing the output. However any of the number fields at least could have spaces considering `LANG=fr_FR df -B\'1`, so it's probably best to leave spaces, which also allows scripts to handle mount points with spaces without change. * src/df.c (hide_problematic_chars): Replace control chars with '?'. * tests/df/problematic-chars: Add a new root only test. * tests/Makefile.am: Reference the new test. * NEWS: Mention the fix.
Diffstat (limited to 'tests')
-rw-r--r--tests/Makefile.am1
-rwxr-xr-xtests/df/problematic-chars44
2 files changed, 45 insertions, 0 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index dfac9a0f3..944c7d2e1 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -31,6 +31,7 @@ root_tests = \
cp/capability \
cp/sparse-fiemap \
dd/skip-seek-past-dev \
+ df/problematic-chars \
install/install-C-root \
ls/capability \
ls/nameless-uid \
diff --git a/tests/df/problematic-chars b/tests/df/problematic-chars
new file mode 100755
index 000000000..801c4d9cf
--- /dev/null
+++ b/tests/df/problematic-chars
@@ -0,0 +1,44 @@
+#!/bin/sh
+# Ensure that df outputs one line per entry
+
+# Copyright (C) 2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ df
+require_root_
+
+mnt='mount
+point'
+
+cwd=$(pwd)
+cleanup_() { cd /; umount "$cwd/$mnt"; }
+
+skip=0
+# Create a file system, then mount it.
+dd if=/dev/zero of=blob bs=8192 count=200 > /dev/null 2>&1 \
+ || skip=1
+mkdir "$mnt" || skip=1
+mkfs -t ext2 -F blob \
+ || skip_ "failed to create ext2 file system"
+
+mount -oloop blob "$mnt" || skip=1
+
+test $skip = 1 \
+ && skip_ "insufficient mount/ext2 support"
+
+test $(df "$mnt" | wc -l) = 2 || fail=1
+
+Exit $fail